using Godot;
using System;

public class BuildMode : Node
{
    [Signal]
    delegate void OnModeEntered();
    [Signal]
    delegate void OnModeExited();

    [Export]
    private KeyList _key;

    public bool Active
    {
        get => _active;
        private set
        {
            if (value == _active)
                return;

            _active = value;

            var signal = _active
                ? nameof(OnModeEntered)
                : nameof(OnModeExited);
            EmitSignal(signal);
        }
    }
    private bool _active;

    private const int NO_TILE_TYPE_SELECTED = -1;

    public int SelectedTileType { get; set; } = NO_TILE_TYPE_SELECTED;

    public override void _Ready()
    {

    }

    public override void _Input(InputEvent @event)
    {
        base._Input(@event);

        if (!(@event is InputEventKey keyEvent))
            return;

        if (!keyEvent.Pressed)
            return;

        var key = (KeyList)keyEvent.Scancode;

        // TODO: this should be developed into a UI stack
        if (key == KeyList.Escape)
        {
            Active = false;
            return;
        }

        if (key == _key)
        {
            Active = true;
            return;
        }
    }
}
